<template>
  <div>
    <!-- TODO SHAME add time function to the sliders -->
  <lory :options="{ enableMouseEvents: true, infinite: 1 }" :hasDotNavigation="true" :hasPrevNext="true" :extraClasses="['home-top-slider']">
    <item v-for="item in headlines.main_headlines" :key="item">
      <router-link :to="'/'+item.slug">
        <div class="slide" :style="{ backgroundImage: 'url(' + image(item) + ')'}"></div>
      </router-link>
    </item>
  </lory>

  <lory :options="{ enableMouseEvents: true, infinite: 1 }" :hasDotNavigation="false" :hasPrevNext="false" :extraClasses="['home-mid-slider']">
    <item v-for="item in headlines.sub_headlines" :key="item">
      <router-link :to="'/'+item.slug">
        <div class="slide" :style="{ backgroundImage: 'url(' + image(item) + ')'}"></div>
      </router-link>
    </item>
  </lory>
  <section class="news-list-container">
    <list-animation>
      <Card appear="true" v-for="item in news_area" :key="item" :card="item" />
    </list-animation>
    <!--<infinite-loading :on-infinite="loadMore" ref="infiniteLoading" :allLoaded="is_complete"></infinite-loading>-->
  </section>
  </div>
</template>

<script>
  // import axios from 'axios'
  // import apiRoutes from '~components/apiRoutes.js'
  // const apiEndPoint = apiRoutes.homepage

  import Lory from '~components/slider/Lory.vue'
  import Item from '~components/slider/Item.vue'

  import Card from '~components/card/cardsq.vue'
  import infiniteLoading from '~components/infiniteLoading.vue'
  import listAnimation from '~components/listAnimation.vue'

  import { mapMutations } from 'vuex'
  /*
  lory as a component
  import Lory from 'vue-lory/src/Lory.vue'
  import Item from 'vue-lory/src/Item.vue'
  import Prev from 'vue-lory/src/Prev.vue'
  import Next from 'vue-lory/src/Next.vue'
  */

  export default {
    fetch ({ store }) {
      store.dispatch('homepage/LOADMORE_LISTVIEW_DATA')
      return store.dispatch('homepage/LOADMORE_LISTVIEW_DATA')
    },
    /*
    // might be usefull in future if the fecth actions is moved from the store
    asyncData ({ req, params }) {
      // We can return a Promise instead of calling the callback
      return axios.get(apiEndPoint)
      .then((res) => {
        return {
          news_area: res.data.news_area,
          headlines: {
            main_headlines: res.data.headlines.main_headlines,
            sub_headlines: res.data.headlines.sub_headlines
          }
        }
      })
    },
    */
    methods: {
      image (src) {
        return src.image_url // image_url2x TODO write a condition for responsive systems
      },
      loadMore () {
        return this.$store.dispatch('homepage/LOADMORE_LISTVIEW_DATA', this.$store.state.homepage.list.length)
      },
      setTopbarSettings () {
        this.$store.commit('pushTopBarLayout', this.topBarSettings.topbarMenu)
        this.$store.dispatch('SET_PAGE_TITLE', this.topBarSettings.pageTitle)
      },
      ...mapMutations({
        closeSidebar: 'closeSidebar'
      })
    },
    computed: {
      news_area () {
        return this.$store.state.homepage.list
      },
      headlines () {
        return this.$store.state.homepage.headlines
      },
      is_complete () {
        let itemListTotal = Number(this.$store.state.homepage.api_headers['x-total-count'])
        if (itemListTotal > this.news_area.length || itemListTotal !== 0 && this.news_area.length === 0) {
          return false
        } else {
          return true
        }
      },
      topBarSettings () {
        return { // copy me to every page with setTopbarSettings actions
          pageTitle: 'MOBİL HABER',
          topbarMenu: {
            isBackIconVisible: false,
            isCardToggleIconVisible: false,
            isFilterIconVisible: false,
            isSearchIconVisible: true,
            isSettingsIconVisible: false,
            isAddFavoritesIconVisible: false
          }
        }
      }
    },
    created () {
      this.closeSidebar()
    },
    beforeMount () {
      this.setTopbarSettings()
    },
    components: {
      Lory,
      Item,
      Card,
      infiniteLoading,
      listAnimation
    }
  }
</script>

<style lang='scss'>



</style>

